package com.ynfy.buss.exam.chouqian.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ynfy.buss.exam.chouqian.entity.CqCqks;
import com.ynfy.buss.exam.chouqian.entity.CqXxxq;
import com.ynfy.buss.exam.chouqian.entity.CqYcqxx;
import com.ynfy.buss.exam.chouqian.service.ICqCqksService;
import com.ynfy.buss.exam.chouqian.service.ICqXxxqService;
import com.ynfy.buss.exam.chouqian.service.ICqYcqxxService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.Objects;


@Api(tags = "抽签")
@RestController
@RequestMapping("/chouqian")
@Slf4j
public class CqXxxqController extends JeecgController<CqXxxq, ICqXxxqService> {
    @Autowired
    private ICqXxxqService cqXxxqService;
    @Autowired
    private ICqYcqxxService cqYcqxxService;
    @Autowired
    private ICqCqksService cqCqksService;
    /**
     * 根据区等级年级获取所有学校
     *
     * @param cqXxxq
     * @return
     */
    @AutoLog(value = "根据区等级年级获取所有学校")
    @ApiOperation(value = "根据区等级年级获取所有学校", notes = "根据区等级年级获取所有学校")
    @GetMapping(value = "/hqxx")
    public Result<List<CqXxxq>> hqxx(CqXxxq cqXxxq) {
        return Result.OK(cqXxxqService.hqxx(cqXxxq));
    }
    /**
     * 学校抽签
     *
     * @param cqXxxq
     * @return
     */
    @AutoLog(value = "抽签")
    @ApiOperation(value = "抽签", notes = "抽签")
    @GetMapping(value = "/cqxx")
    public Result<Map<String,List<CqXxxq>>> cqxx(CqXxxq cqXxxq) {
            return Result.OK(cqXxxqService.cqxx(cqXxxq));
    }
    /**
     * 班级抽签 抽签
     *
     * @param
     * @return
     */
    @AutoLog(value = "班级抽签")
    @ApiOperation(value = "班级抽签", notes = "班级抽签")
    @GetMapping(value = "/bjcq")
    public Result<String> bjcq(String districtname) {
        return Result.OK(cqXxxqService.bjcq(districtname));
    }
    /**
     * 班级抽签 抽签
     *
     * @param
     * @return
     */
    @AutoLog(value = "人员抽签")
    @ApiOperation(value = "人员抽签", notes = "人员抽签")
    @GetMapping(value = "/rycq")
    public Result<String> rycq(CqXxxq cqXxxq) {
        cqXxxqService.rycq(cqXxxq);
        return Result.OK("抽签完成");
    }
    //获取有几个地市
    /**
     * 获取有几个地市
     *
     * @param
     * @return
     */
    @AutoLog(value = "获取地市")
    @ApiOperation(value = "获取地市", notes = "获取地市")
    @GetMapping(value = "/huoquds")
    public Result<List<String>> huoquds() {
        return Result.OK(cqXxxqService.huoquds());
    }
    /**
     * 根据地市获取等级
     */
    @AutoLog(value = "根据地市获取等级")
    @ApiOperation(value = "根据地市获取等级", notes = "根据地市获取等级")
    @GetMapping(value = "/huoqudsxxdj")
    public Result<List<String>> huoqudsxxdj(String districtname) {
        return Result.OK(cqXxxqService.huoqudsxxdj(districtname));
    }
    /**
     * 根据地市获取几个年级
     */
    @AutoLog(value = "根据地市获取年级")
    @ApiOperation(value = "根据地市获取年级", notes = "根据地市获取年级")
    @GetMapping(value = "/huoqudsxxnj")
    public Result<List<String>> huoqudsxxnj(String districtname) {
        return Result.OK(cqXxxqService.huoqudsxxnj(districtname));
    }
    /**
     * 分页以抽签学校查询
     *
     * @param cqYcqxx
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @ApiOperation(value = "分页以抽签学校查询", notes = "分页以抽签学校查询")
    @GetMapping(value = "/xxlist")
    public Result<IPage<CqYcqxx>> xxPageList(CqYcqxx cqYcqxx,
                                             @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                             @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                             HttpServletRequest req) {
        QueryWrapper<CqYcqxx> queryWrapper = QueryGenerator.initQueryWrapper(cqYcqxx, req.getParameterMap());
        Page<CqYcqxx> page = new Page<CqYcqxx>(pageNo, pageSize);
        IPage<CqYcqxx> pageList = cqYcqxxService.page(page, queryWrapper);
////        //测试添加
//        System.err.println("显示查询条件："+cqYcqxx);
//        cqXxxqService.bjcq(cqYcqxx.getDistrictname());

        return Result.OK(pageList);
    }
    /**
     * 分页以抽签学生查询
     *
     * @param cqCqks
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @ApiOperation(value = "分页以抽签学生查询", notes = "分页以抽签学生查询")
    @GetMapping(value = "/kslist")
    public Result<IPage<CqCqks>> ksList(CqCqks cqCqks,
                                         @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                         @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                         HttpServletRequest req) {
        QueryWrapper<CqCqks> queryWrapper = QueryGenerator.initQueryWrapper(cqCqks, req.getParameterMap());
        Page<CqCqks> page = new Page<CqCqks>(pageNo, pageSize);
        IPage<CqCqks> pageList = cqCqksService.page(page, queryWrapper);
//        //测试添加
//        CqXxxq cqXxxq=new CqXxxq();
//        cqXxxq.setDistrictname(cqCqks.getDistrictname());
//        cqXxxq.setNianji(cqCqks.getNianji());
//        cqXxxqService.rycq(cqXxxq);
        return Result.OK(pageList);
    }
    /**
     * 导出excel
     * @param request
     */
    @RequestMapping(value = "/xxexportXls")
    public ModelAndView xxexportXls(CqYcqxx cqYcqxx, HttpServletRequest request) {

        // Step.1 组装查询条件
        QueryWrapper<CqYcqxx> queryWrapper = QueryGenerator.initQueryWrapper(cqYcqxx, request.getParameterMap());
        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<CqYcqxx> pageList = cqYcqxxService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME,"抽签学校列表");
        mv.addObject(NormalExcelConstants.CLASS,CqYcqxx.class);
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        mv.addObject(NormalExcelConstants.PARAMS,new ExportParams("抽签学校列表数据","导出人:"+user.getRealname(),"导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST,pageList);
        return mv;
    }
    /**
     * 导出excel
     * @param request
     */
    @RequestMapping(value = "/ksexportXls")
    public ModelAndView ksexportXls(CqCqks cqCqks, HttpServletRequest request) {
        // Step.1 组装查询条件
        QueryWrapper<CqCqks> queryWrapper = QueryGenerator.initQueryWrapper(cqCqks, request.getParameterMap());
        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<CqCqks> pageList = cqCqksService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME,"抽签人员列表");
        mv.addObject(NormalExcelConstants.CLASS,CqCqks.class);
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        mv.addObject(NormalExcelConstants.PARAMS,new ExportParams("抽签人员数据","导出人:"+user.getRealname(),"导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST,pageList);
        return mv;
    }
    /**
     *一键清除所有抽签记录
     *
     */
    @AutoLog(value = "清除所有抽签记录")
    @ApiOperation(value = "清除所有抽签记录", notes = "清除所有抽签记录")
    @GetMapping(value = "/qccqxx")
    public Result<String> qccqxx() {
        cqXxxqService.qccqxx();
        return Result.OK("清除成功");
    }
}
